/*
 * TismTool  Tis Veugen, 2010-2012
 *
 * File: Driver.cpp
 */

#include <cstring>
#include <cstdlib>
#include "Tsm.h"
#include "Driver.h"

namespace Foreign
{  
  DriverClass::DriverClass( TsmBase* oParent, string sInstanceName )
    : dPar( 1.0 )
    , L10( 55 )
  {
    TsmPI__Port = new MyTsmIPort_IDriverServer( this );
  }

  DriverClass::~DriverClass()
  {
    delete TsmPI__Port;
  }

  TsmInterfacePort* DriverClass::GetProvidedInterface( string sPortName )
  {
    if ( sPortName == "DriverPort" )
    {
      return TsmPI__Port;
    }
    string s = "No port '" + sPortName + "' @ DriverClass";
    throw TsmException( s );
  }

  void DriverClass::SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
  {
    if ( sPortName == "DriverPort" )
    {
      Port = static_cast<TsmIPort_ICbDriverServer*>(oProvidedInterface);
      // Do NOT fill in Port->Source !!
      return;
    }
    string s = "No port '" + sPortName + "' @ DriverClass";
    throw TsmException( s );
  }

  // ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
  long DriverClass::Begin( int iPar )
  {
    Port->CbBegin( dPar );
    return L10;
  }


  DriverForeign::DriverForeign( TsmBase* oParent, string sInstanceName )
  {
    m_DriverClass = new DriverClass( this, "DriverClass" );
  }

  DriverForeign::~DriverForeign()
  {
    delete m_DriverClass;
  }

  TsmInterfacePort* DriverForeign::GetProvidedInterface( string sPortName )
  {
    if ( sPortName == "d_pp_Driver" )
    {
      return m_DriverClass->GetProvidedInterface( "DriverPort" );
    }
    string s = "No port '" + sPortName + "' @ DriverForeign";
    throw TsmException( s );
  }

  void DriverForeign::SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
  {
    if ( sPortName == "d_pp_Driver" )
    {
      m_DriverClass->SetRequiredInterface( "DriverPort", oProvidedInterface );
      return;
    }
    string s = "No port '" + sPortName + "' @ DriverForeign";
    throw TsmException( s );
  }
}