/*
 * TismTool  Tis Veugen, 2010-2012
 *
 * File: Driver.h
 */

#ifndef DRIVER_H
#define DRIVER_H

#include "TsmBase.h"
#include "TsmClass.h"
#include "TsmPComponent.h"
#include "TsmInterfaces.h"
using namespace std;
using namespace TsmRTE;

namespace Foreign
{
  class MyTsmIPort_IDriverServer;
  class DriverClass : public TsmClass, public IDriverServer
  {
  private:
    MyTsmIPort_IDriverServer* TsmPI__Port;
    TsmIPort_ICbDriverServer* Port;

    double dPar;
    long L10;

  public:
    DriverClass( TsmBase* oParent, string sInstanceName );
    virtual ~DriverClass();

    TsmInterfacePort* GetProvidedInterface( string sPortName );
    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface );

    // ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    long Begin( int iPar );
  };


  class DriverForeign : public TsmPComponent
  {
  private:
    DriverClass* m_DriverClass;

  public:
    DriverForeign( TsmBase* oParent, string sInstanceName );
    virtual ~DriverForeign();

    TsmInterfacePort* GetProvidedInterface( string sPortName );
    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface );
  };


  class MyTsmIPort_IDriverServer : public TsmIPort_IDriverServer
  {
  private:
    DriverClass* m_DriverClass;

  public:
    MyTsmIPort_IDriverServer( DriverClass* oParent )
      : TsmIPort_IDriverServer( oParent )
      , m_DriverClass( oParent )
    {
    }

    long Begin( int iPar )
    {
      return m_DriverClass->Begin( iPar );
    }
  };
}
#endif
