/*
 * File: TsmSystem.h
 * Date: 12 aug 2012
 * Time: 19:23:27
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *      7 ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
 *      8 ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
 *     20 ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
 *     21 ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
 *     39 ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
 *     51 ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
 *     63 ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
 *     73 ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
 *     84 ( Xmi > Data > Protocols > Driver > DriverClient > Port )
 *     94 ( Xmi > Data > Protocols > Driver > DriverServer > Port )
 * Triggers:
 *      1 int ICtlrServer___Start( Boolean bStart )
 *      2 void ICbDriverServer___CbBegin( double dPar )
 *      3 long IDriverServer___Begin( int iPar )
 *      4 void ICbCtlrServer___CbStarted( float fCbStart )
 * Natives:
 *    -70 ( CtlrClientPsm >> Idle ) ->
 *        ( CtlrClientPsm >> Starting )
 *        iRv=Start(true);
 *     81 ( CtlrServerPsm >> Starting ) ->
 *        ( CtlrServerPsm >> Idle )
 *        CbStarted((float)3.14);
 *    -91 ( DriverClientPsm >> Idle ) ->
 *        ( DriverClientPsm >> Beginning )
 *        lRv = Begin(iBeginPar);
 *    102 ( DriverServerPsm >> Beginning ) ->
 *        ( DriverServerPsm >> Idle )
 *        CbBegin( dPar );
 *    103 ( DriverServerPsm >> Beginning ) ->
 *        ( DriverServerPsm >> Idle )
 *        CbBegin( 3.14 );
 */

#ifndef TSM_SYSTEM_H
#define TSM_SYSTEM_H

#include "TsmIncludes.h"
#include "TsmInterfaces.h"
using namespace std;
using namespace TsmRTE;
/* Included from file: C:\WORKSPACES\CPP\FOREIGN\ForeignInclude_Cpp.inc */
#include "User.h"
#include "Driver.h"


namespace Foreign
{
   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
  class Ini_0010_0011 : public TsmPseudo
  {
  public:
    Ini_0010_0011( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 14, "( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14: // UP: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Idle )
  class Lea_0010_0012 : public TsmLeaf
  {
  public:
    Lea_0010_0012( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 15, "( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting ) : pp_User->Start" );
    }

    void Tra_0010_0014( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_User___Start( bool bStart, TsmHandler& oHandler );
    void Tra_0010_0016( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 7:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14:
        Tra_0010_0014( oHandler );
        break;
      case 15: // UP: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
        bHigher = true;
        break;
      case 16:
        Tra_0010_0016( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Starting )
  class Lea_0010_0013 : public TsmLeaf
  {
  public:
    Lea_0010_0013( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 16, "( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle ) : rp_Driver->CbBegin" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0010_0015( TsmHandler& oHandler );
    void rp_Driver___CbBegin( double dPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 8:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 15:
        Tra_0010_0015( oHandler );
        break;
      case 16: // UP: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >)
  class Reg_0009_0010 : public TsmRegion
  {
  private:
    Ini_0010_0011* oIni_0010_0011; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
    Lea_0010_0012* oLea_0010_0012; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Idle )
    Lea_0010_0013* oLea_0010_0013; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Starting )

  public:
    Reg_0009_0010( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0010_0011 = new Ini_0010_0011( this );
      oLea_0010_0012 = new Lea_0010_0012( this );
      oLea_0010_0013 = new Lea_0010_0013( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0010_0011;
      mStates[ 1 ] = oLea_0010_0012;
      mStates[ 2 ] = oLea_0010_0013;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0010_0014( TsmHandler& oHandler );
    void Tra_0010_0015( TsmHandler& oHandler );
    void Tra_0010_0016( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 7:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 7
      case 8:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14:
        Tra_0010_0014( oHandler );
        break;
      case 15:
        Tra_0010_0015( oHandler );
        break;
      case 16:
        Tra_0010_0016( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm )
  class Fsm_0006_0009 : public TsmFsm
  {
  private:
    Reg_0009_0010* oReg_0009_0010; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >)

  public:
    Fsm_0006_0009( TsmBase* oParent )
    {
      TsmName = "CtlrClassFsm";
      TsmParent = oParent;
      oReg_0009_0010 = new Reg_0009_0010( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0009_0010;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )
  class Cla_0004_0006 : public TsmClass
  {
  private:
    Fsm_0006_0009* oFsm_0006_0009; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm )
    TsmIPort_ICtlrServer* TsmPI__pp_User; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
    TsmIPort_ICbCtlrServer* pp_User; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
    TsmIPort_IDriverServer* rp_Driver; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
    TsmIPort_ICbDriverServer* TsmPI__rp_Driver; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    bool bCtrlStart;
    double MyCtlrlCbPar;

  public:
    Cla_0004_0006( TsmBase* oParent, string sInstanceName ) : bCtrlStart(false)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0006_0009 = new Fsm_0006_0009( this );
      TsmPI__pp_User = new TsmIPort_ICtlrServer( this );
      TsmPI__rp_Driver = new TsmIPort_ICbDriverServer( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0006_0009;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_User" )
      {
        return TsmPI__pp_User;
      }
      if ( sPortName == "rp_Driver" )
      {
        return TsmPI__rp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_User" )
      {
        pp_User = static_cast<TsmIPort_ICbCtlrServer*>(oProvidedInterface);
        pp_User->Source = this;
        return;
      }
      if ( sPortName == "rp_Driver" )
      {
        rp_Driver = static_cast<TsmIPort_IDriverServer*>(oProvidedInterface);
        rp_Driver->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0006_0009->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1008( TsmHandler& oHandler );
    void Function_1009( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0004_0006()
    {
      delete TsmPI__pp_User;
      delete TsmPI__rp_Driver;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Controller > CtlrComp )
  class Com_0003_0004 : public TsmLComponent
  {
  private:
    Cla_0004_0006* MyCtlrClass; // ( Xmi > Data > Repository > Controller > CtlrComp > MyCtlrClass )

  public:
    Com_0003_0004( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyCtlrClass = new Cla_0004_0006( this, "MyCtlrClass" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = MyCtlrClass;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_User" )
      {
        return MyCtlrClass->GetProvidedInterface( "pp_User" );
      }
      if ( sPortName == "d_rp_Driver" )
      {
        return MyCtlrClass->GetProvidedInterface( "rp_Driver" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_User" )
      {
        MyCtlrClass->SetRequiredInterface( "pp_User", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_Driver" )
      {
        MyCtlrClass->SetRequiredInterface( "rp_Driver", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
  class Ini_0023_0024 : public TsmPseudo
  {
  public:
    Ini_0023_0024( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 27, "( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27: // UP: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Idle )
  class Lea_0023_0025 : public TsmLeaf
  {
  public:
    Lea_0023_0025( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 28, "( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting ) : pp_User->Start" );
    }

    void Tra_0023_0027( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void pp_User___Start( bool bStart, TsmHandler& oHandler );
    void Tra_0023_0029( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 20:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0023_0027( oHandler );
        break;
      case 28: // UP: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
        bHigher = true;
        break;
      case 29:
        Tra_0023_0029( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Starting )
  class Lea_0023_0026 : public TsmLeaf
  {
  public:
    Lea_0023_0026( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 29, "( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle ) : rp_Driver->CbBegin" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0023_0028( TsmHandler& oHandler );
    void rp_Driver___CbBegin( double dPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 21:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 28:
        Tra_0023_0028( oHandler );
        break;
      case 29: // UP: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >)
  class Reg_0022_0023 : public TsmRegion
  {
  private:
    Ini_0023_0024* oIni_0023_0024; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
    Lea_0023_0025* oLea_0023_0025; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Idle )
    Lea_0023_0026* oLea_0023_0026; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Starting )

  public:
    Reg_0022_0023( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0023_0024 = new Ini_0023_0024( this );
      oLea_0023_0025 = new Lea_0023_0025( this );
      oLea_0023_0026 = new Lea_0023_0026( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0023_0024;
      mStates[ 1 ] = oLea_0023_0025;
      mStates[ 2 ] = oLea_0023_0026;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0023_0027( TsmHandler& oHandler );
    void Tra_0023_0028( TsmHandler& oHandler );
    void Tra_0023_0029( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 20:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 20
      case 21:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0023_0027( oHandler );
        break;
      case 28:
        Tra_0023_0028( oHandler );
        break;
      case 29:
        Tra_0023_0029( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm )
  class Fsm_0019_0022 : public TsmFsm
  {
  private:
    Reg_0022_0023* oReg_0022_0023; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >)

  public:
    Fsm_0019_0022( TsmBase* oParent )
    {
      TsmName = "CtlrClassFsm";
      TsmParent = oParent;
      oReg_0022_0023 = new Reg_0022_0023( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0022_0023;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )
  class Cla_0017_0019 : public TsmClass
  {
  private:
    Fsm_0019_0022* oFsm_0019_0022; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm )
    TsmIPort_ICtlrServer* TsmPI__pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
    TsmIPort_ICbCtlrServer* pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
    TsmIPort_IDriverServer* rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
    TsmIPort_ICbDriverServer* TsmPI__rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
    TsmPSPort* mPSMessager;
    TsmPCPort* mPCMessager;
    bool bCtrlStart;
    double MyCtlrlCbPar;

  public:
    Cla_0017_0019( TsmBase* oParent, string sInstanceName ) : bCtrlStart(true)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0019_0022 = new Fsm_0019_0022( this );
      TsmPI__pp_User = new TsmIPort_ICtlrServer( this );
      TsmPI__rp_Driver = new TsmIPort_ICbDriverServer( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0019_0022;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_User" )
      {
        return TsmPI__pp_User;
      }
      if ( sPortName == "rp_Driver" )
      {
        return TsmPI__rp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_User" )
      {
        pp_User = static_cast<TsmIPort_ICbCtlrServer*>(oProvidedInterface);
        pp_User->Source = this;
        return;
      }
      if ( sPortName == "rp_Driver" )
      {
        rp_Driver = static_cast<TsmIPort_IDriverServer*>(oProvidedInterface);
        rp_Driver->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0019_0022->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1010( TsmHandler& oHandler );
    void Function_1011( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0017_0019()
    {
      delete TsmPI__pp_User;
      delete TsmPI__rp_Driver;
      delete mPSMessager;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp )
  class Com_0003_0017 : public TsmAComponent
  {
  private:
    Cla_0017_0019* MyCtlrClass; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > MyCtlrClass )
    TsmIPort_ICtlrServer* TsmPI__d_pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > d_pp_User )
    TsmASPort* TsmMr__d_pp_User;
    TsmIPort_ICbDriverServer* TsmPI__d_rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > d_rp_Driver )
    TsmACPort* TsmMr__d_rp_Driver;

  public:
    Com_0003_0017( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyCtlrClass = new Cla_0017_0019( this, "MyCtlrClass" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = MyCtlrClass;
      TsmPI__d_pp_User = new TsmIPort_ICtlrServer( this );
      TsmMr__d_pp_User = new TsmASPort();
      TsmPI__d_rp_Driver = new TsmIPort_ICbDriverServer( this );
      TsmMr__d_rp_Driver = new TsmACPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_User" )
      {
        return TsmPI__d_pp_User;
      }
      if ( sPortName == "d_rp_Driver" )
      {
        return TsmPI__d_rp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_User" )
      {
        MyCtlrClass->SetRequiredInterface( "pp_User", oProvidedInterface );
        return;
      }
      if ( sPortName == "d_rp_Driver" )
      {
        MyCtlrClass->SetRequiredInterface( "rp_Driver", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0003_0017()
    {
      delete TsmPI__d_pp_User;
      delete TsmMr__d_pp_User;
      delete TsmPI__d_rp_Driver;
      delete TsmMr__d_rp_Driver;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Controller )
   ********************************************************************/

   // ( Xmi > Data > Repository > Controller )
  class Pac_0002_0003 : public TsmPackage
  {
  public:
    Pac_0002_0003( TsmBase* oParent )
    {
      TsmName = "Controller";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > UserForeign )
  class Com_0030_0031 : public TsmPComponent
  {
  public:
    Com_0030_0031( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > DriverForeign )
  class Com_0030_0032 : public TsmPComponent
  {
  public:
    Com_0030_0032( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > DriverMock )
  class Com_0030_0033 : public TsmPComponent
  {
  public:
    Com_0030_0033( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Terminators > UserMock )
  class Com_0030_0034 : public TsmPComponent
  {
  public:
    Com_0030_0034( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Terminators )
   ********************************************************************/

   // ( Xmi > Data > Repository > Terminators )
  class Pac_0002_0030 : public TsmPackage
  {
  public:
    Pac_0002_0030( TsmBase* oParent )
    {
      TsmName = "Terminators";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> InitialState )
  class Ini_0041_0042 : public TsmPseudo
  {
  public:
    Ini_0041_0042( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 45, "( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45: // UP: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Idle )
  class Lea_0041_0043 : public TsmLeaf
  {
  public:
    Lea_0041_0043( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 46, "( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning ) : pp_Driver->Begin" );
    }

    void Tra_0041_0045( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0041_0047( TsmHandler& oHandler );
    void pp_Driver___Begin( int iPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 39:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45:
        Tra_0041_0045( oHandler );
        break;
      case 47:
        Tra_0041_0047( oHandler );
        break;
      case 46: // UP: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Beginning )
  class Lea_0041_0044 : public TsmLeaf
  {
  public:
    Lea_0041_0044( TsmBase* oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 47, "( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0041_0046( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 47: // UP: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      case 46:
        Tra_0041_0046( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >)
  class Reg_0040_0041 : public TsmRegion
  {
  private:
    Ini_0041_0042* oIni_0041_0042; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> InitialState )
    Lea_0041_0043* oLea_0041_0043; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Idle )
    Lea_0041_0044* oLea_0041_0044; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Beginning )

  public:
    Reg_0040_0041( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0041_0042 = new Ini_0041_0042( this );
      oLea_0041_0043 = new Lea_0041_0043( this );
      oLea_0041_0044 = new Lea_0041_0044( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0041_0042;
      mStates[ 1 ] = oLea_0041_0043;
      mStates[ 2 ] = oLea_0041_0044;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0041_0045( TsmHandler& oHandler );
    void Tra_0041_0047( TsmHandler& oHandler );
    void Tra_0041_0046( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 39:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45:
        Tra_0041_0045( oHandler );
        break;
      case 47:
        Tra_0041_0047( oHandler );
        break;
      case 46:
        Tra_0041_0046( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm )
  class Fsm_0038_0040 : public TsmFsm
  {
  private:
    Reg_0040_0041* oReg_0040_0041; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >)

  public:
    Fsm_0038_0040( TsmBase* oParent )
    {
      TsmName = "DriverClassFsm";
      TsmParent = oParent;
      oReg_0040_0041 = new Reg_0040_0041( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0040_0041;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )
  class Cla_0036_0038 : public TsmClass
  {
  private:
    Fsm_0038_0040* oFsm_0038_0040; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm )
    TsmIPort_IDriverServer* TsmPI__pp_Driver; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
    TsmIPort_ICbDriverServer* pp_Driver; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
    TsmPSPort* mPSMessager;

  public:
    Cla_0036_0038( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0038_0040 = new Fsm_0038_0040( this );
      TsmPI__pp_Driver = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0038_0040;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_Driver" )
      {
        return TsmPI__pp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_Driver" )
      {
        pp_Driver = static_cast<TsmIPort_ICbDriverServer*>(oProvidedInterface);
        pp_Driver->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0038_0040->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1001( TsmHandler& oHandler );
    long Function_1012( int iPar );
    void Function_1013( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0036_0038()
    {
      delete TsmPI__pp_Driver;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Repository > Driver > DriverComp )
  class Com_0035_0036 : public TsmPComponent
  {
  private:
    Cla_0036_0038* MyDriverClass; // ( Xmi > Data > Repository > Driver > DriverComp > MyDriverClass )

  public:
    Com_0035_0036( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyDriverClass = new Cla_0036_0038( this, "MyDriverClass" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = MyDriverClass;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        return MyDriverClass->GetProvidedInterface( "pp_Driver" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        MyDriverClass->SetRequiredInterface( "pp_Driver", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> InitialState )
  class Ini_0053_0054 : public TsmPseudo
  {
  public:
    Ini_0053_0054( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57: // UP: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Idle )
  class Lea_0053_0055 : public TsmLeaf
  {
  public:
    Lea_0053_0055( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 58, "( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning ) : pp_Driver->Begin" );
    }

    void Tra_0053_0057( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0053_0059( TsmHandler& oHandler );
    void pp_Driver___Begin( int iPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 51:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0053_0057( oHandler );
        break;
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 58: // UP: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Beginning )
  class Lea_0053_0056 : public TsmLeaf
  {
  public:
    Lea_0053_0056( TsmBase* oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 59, "( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0053_0058( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 59: // UP: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      case 58:
        Tra_0053_0058( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >)
  class Reg_0052_0053 : public TsmRegion
  {
  private:
    Ini_0053_0054* oIni_0053_0054; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> InitialState )
    Lea_0053_0055* oLea_0053_0055; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Idle )
    Lea_0053_0056* oLea_0053_0056; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Beginning )

  public:
    Reg_0052_0053( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0053_0054 = new Ini_0053_0054( this );
      oLea_0053_0055 = new Lea_0053_0055( this );
      oLea_0053_0056 = new Lea_0053_0056( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0053_0054;
      mStates[ 1 ] = oLea_0053_0055;
      mStates[ 2 ] = oLea_0053_0056;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0053_0057( TsmHandler& oHandler );
    void Tra_0053_0059( TsmHandler& oHandler );
    void Tra_0053_0058( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 51:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0053_0057( oHandler );
        break;
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 58:
        Tra_0053_0058( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm )
  class Fsm_0050_0052 : public TsmFsm
  {
  private:
    Reg_0052_0053* oReg_0052_0053; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >)

  public:
    Fsm_0050_0052( TsmBase* oParent )
    {
      TsmName = "DriverClassFsm";
      TsmParent = oParent;
      oReg_0052_0053 = new Reg_0052_0053( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0052_0053;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )
  class Cla_0048_0050 : public TsmClass
  {
  private:
    Fsm_0050_0052* oFsm_0050_0052; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm )
    TsmIPort_IDriverServer* TsmPI__pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
    TsmIPort_ICbDriverServer* pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
    TsmPSPort* mPSMessager;

  public:
    Cla_0048_0050( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0050_0052 = new Fsm_0050_0052( this );
      TsmPI__pp_Driver = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0050_0052;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_Driver" )
      {
        return TsmPI__pp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_Driver" )
      {
        pp_Driver = static_cast<TsmIPort_ICbDriverServer*>(oProvidedInterface);
        pp_Driver->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0050_0052->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1002( TsmHandler& oHandler );
    long Function_1014( int iPar );
    void Function_1015( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0048_0050()
    {
      delete TsmPI__pp_Driver;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Repository > Driver > ThrDriverComp )
  class Com_0035_0048 : public TsmAComponent
  {
  private:
    Cla_0048_0050* MyDriverClass; // ( Xmi > Data > Repository > Driver > ThrDriverComp > MyDriverClass )
    TsmIPort_IDriverServer* TsmPI__d_pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > d_pp_Driver )
    TsmASPort* TsmMr__d_pp_Driver;

  public:
    Com_0035_0048( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyDriverClass = new Cla_0048_0050( this, "MyDriverClass" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = MyDriverClass;
      TsmPI__d_pp_Driver = new TsmIPort_IDriverServer( this );
      TsmMr__d_pp_Driver = new TsmASPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        return TsmPI__d_pp_Driver;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        MyDriverClass->SetRequiredInterface( "pp_Driver", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0035_0048()
    {
      delete TsmPI__d_pp_Driver;
      delete TsmMr__d_pp_Driver;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Driver )
   ********************************************************************/

   // ( Xmi > Data > Repository > Driver )
  class Pac_0002_0035 : public TsmPackage
  {
  public:
    Pac_0002_0035( TsmBase* oParent )
    {
      TsmName = "Driver";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  class Pac_0001_0002 : public TsmPackage
  {
  public:
    Pac_0001_0002( TsmBase* oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> InitialState )
  class Ini_0065_0066 : public TsmPseudo
  {
  public:
    Ini_0065_0066( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 69, "( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69: // UP: ( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Idle )
  class Lea_0065_0067 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0065_0067( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 70, "( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )" );
    }

    void Tra_0065_0069( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0065_0071( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 70:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0065_0069( oHandler );
        break;
      case 70: // UP: ( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 71:
        Tra_0065_0071( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Starting )
  class Lea_0065_0068 : public TsmLeaf
  {
  public:
    Lea_0065_0068( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 71, "( CtlrClientPsm >> Starting ) => ( CtlrClientPsm >> Idle ) : CbStarted" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0065_0070( TsmHandler& oHandler );
    void Port___CbStarted( float fCbStart, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 63:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 70:
        Tra_0065_0070( oHandler );
        break;
      case 71: // UP: ( CtlrClientPsm >> Starting ) => ( CtlrClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >)
  class Reg_0064_0065 : public TsmRegion
  {
  private:
    Ini_0065_0066* oIni_0065_0066; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> InitialState )
    Lea_0065_0067* oLea_0065_0067; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Idle )
    Lea_0065_0068* oLea_0065_0068; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Starting )

  public:
    Reg_0064_0065( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0065_0066 = new Ini_0065_0066( this );
      oLea_0065_0067 = new Lea_0065_0067( this );
      oLea_0065_0068 = new Lea_0065_0068( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0065_0066;
      mStates[ 1 ] = oLea_0065_0067;
      mStates[ 2 ] = oLea_0065_0068;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0065_0069( TsmHandler& oHandler );
    void Tra_0065_0070( TsmHandler& oHandler );
    void Tra_0065_0071( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 70:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 63:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0065_0069( oHandler );
        break;
      case 70:
        Tra_0065_0070( oHandler );
        break;
      case 71:
        Tra_0065_0071( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm )
  class Fsm_0062_0064 : public TsmFsm
  {
  private:
    Reg_0064_0065* oReg_0064_0065; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >)

  public:
    Fsm_0062_0064( TsmBase* oParent )
    {
      TsmName = "CtlrClientPsm";
      TsmParent = oParent;
      oReg_0064_0065 = new Reg_0064_0065( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0064_0065;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient )
  class Cla_0061_0062 : public TsmProtocolClass
  {
  private:
    Fsm_0062_0064* oFsm_0062_0064; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm )
    TsmIPort_ICtlrServer* Port; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
    TsmIPort_ICbCtlrServer* TsmPI__Port; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
    TsmPCPort* mPCMessager;
    int iRv;

  public:
    Cla_0061_0062( TsmBase* oParent, string sInstanceName ) : iRv(0)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0062_0064 = new Fsm_0062_0064( this );
      TsmPI__Port = new TsmIPort_ICbCtlrServer( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0062_0064;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICtlrServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0062_0064->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1003( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0061_0062()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> InitialState )
  class Ini_0075_0076 : public TsmPseudo
  {
  public:
    Ini_0075_0076( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 79, "( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79: // UP: ( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Idle )
  class Lea_0075_0077 : public TsmLeaf
  {
  public:
    Lea_0075_0077( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 80, "( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting ) : Start" );
    }

    void Tra_0075_0079( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0075_0081( TsmHandler& oHandler );
    void Port___Start( bool bStart, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 73:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0075_0079( oHandler );
        break;
      case 81:
        Tra_0075_0081( oHandler );
        break;
      case 80: // UP: ( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Starting )
  class Lea_0075_0078 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0075_0078( TsmBase* oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 81, "( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0075_0080( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 81:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 81: // UP: ( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 80:
        Tra_0075_0080( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >)
  class Reg_0074_0075 : public TsmRegion
  {
  private:
    Ini_0075_0076* oIni_0075_0076; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> InitialState )
    Lea_0075_0077* oLea_0075_0077; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Idle )
    Lea_0075_0078* oLea_0075_0078; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Starting )

  public:
    Reg_0074_0075( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0075_0076 = new Ini_0075_0076( this );
      oLea_0075_0077 = new Lea_0075_0077( this );
      oLea_0075_0078 = new Lea_0075_0078( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0075_0076;
      mStates[ 1 ] = oLea_0075_0077;
      mStates[ 2 ] = oLea_0075_0078;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0075_0079( TsmHandler& oHandler );
    void Tra_0075_0081( TsmHandler& oHandler );
    void Tra_0075_0080( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 81:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 73:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0075_0079( oHandler );
        break;
      case 81:
        Tra_0075_0081( oHandler );
        break;
      case 80:
        Tra_0075_0080( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm )
  class Fsm_0072_0074 : public TsmFsm
  {
  private:
    Reg_0074_0075* oReg_0074_0075; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >)

  public:
    Fsm_0072_0074( TsmBase* oParent )
    {
      TsmName = "CtlrServerPsm";
      TsmParent = oParent;
      oReg_0074_0075 = new Reg_0074_0075( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0074_0075;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer )
  class Cla_0061_0072 : public TsmProtocolClass
  {
  private:
    Fsm_0072_0074* oFsm_0072_0074; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm )
    TsmIPort_ICtlrServer* TsmPI__Port; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
    TsmIPort_ICbCtlrServer* Port; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
    TsmPSPort* mPSMessager;

  public:
    Cla_0061_0072( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0072_0074 = new Fsm_0072_0074( this );
      TsmPI__Port = new TsmIPort_ICtlrServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0072_0074;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICbCtlrServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0072_0074->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1004( TsmHandler& oHandler );
    int Function_1016( bool bStart );
    void Function_1017( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0061_0072()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > Ctlr )
   ********************************************************************/

   // ( Xmi > Data > Protocols > Ctlr )
  class Pac_0060_0061 : public TsmPackage
  {
  public:
    Pac_0060_0061( TsmBase* oParent )
    {
      TsmName = "Ctlr";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> InitialState )
  class Ini_0086_0087 : public TsmPseudo
  {
  public:
    Ini_0086_0087( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 90, "( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90: // UP: ( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Idle )
  class Lea_0086_0088 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0086_0088( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 91, "( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )" );
    }

    void Tra_0086_0090( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0086_0092( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91: // UP: ( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Beginning )
  class Lea_0086_0089 : public TsmLeaf
  {
  public:
    Lea_0086_0089( TsmBase* oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 92, "( DriverClientPsm >> Beginning ) => ( DriverClientPsm >> Idle ) : CbBegin" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0086_0091( TsmHandler& oHandler );
    void Port___CbBegin( double dPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 84:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92: // UP: ( DriverClientPsm >> Beginning ) => ( DriverClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >)
  class Reg_0085_0086 : public TsmRegion
  {
  private:
    Ini_0086_0087* oIni_0086_0087; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> InitialState )
    Lea_0086_0088* oLea_0086_0088; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Idle )
    Lea_0086_0089* oLea_0086_0089; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Beginning )

  public:
    Reg_0085_0086( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0086_0087 = new Ini_0086_0087( this );
      oLea_0086_0088 = new Lea_0086_0088( this );
      oLea_0086_0089 = new Lea_0086_0089( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0086_0087;
      mStates[ 1 ] = oLea_0086_0088;
      mStates[ 2 ] = oLea_0086_0089;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0086_0090( TsmHandler& oHandler );
    void Tra_0086_0091( TsmHandler& oHandler );
    void Tra_0086_0092( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 84:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm )
  class Fsm_0083_0085 : public TsmFsm
  {
  private:
    Reg_0085_0086* oReg_0085_0086; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >)

  public:
    Fsm_0083_0085( TsmBase* oParent )
    {
      TsmName = "DriverClientPsm";
      TsmParent = oParent;
      oReg_0085_0086 = new Reg_0085_0086( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0085_0086;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > Driver > DriverClient )
  class Cla_0082_0083 : public TsmProtocolClass
  {
  private:
    Fsm_0083_0085* oFsm_0083_0085; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm )
    TsmIPort_IDriverServer* Port; // ( Xmi > Data > Protocols > Driver > DriverClient > Port )
    TsmIPort_ICbDriverServer* TsmPI__Port; // ( Xmi > Data > Protocols > Driver > DriverClient > Port )
    TsmPCPort* mPCMessager;
    long lRv;
    double dCbPar;
    int iBeginPar;

  public:
    Cla_0082_0083( TsmBase* oParent, string sInstanceName ) : lRv(0), iBeginPar(101)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0083_0085 = new Fsm_0083_0085( this );
      TsmPI__Port = new TsmIPort_ICbDriverServer( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0083_0085;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IDriverServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0083_0085->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1005( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0082_0083()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> InitialState )
  class Ini_0096_0097 : public TsmPseudo
  {
  public:
    Ini_0096_0097( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 100, "( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100: // UP: ( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Idle )
  class Lea_0096_0098 : public TsmLeaf
  {
  public:
    Lea_0096_0098( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning ) : Begin" );
    }

    void Tra_0096_0100( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0096_0102( TsmHandler& oHandler );
    void Tra_0096_0103( TsmHandler& oHandler );
    void Port___Begin( int iPar, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 94:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 103:
        Tra_0096_0103( oHandler );
        break;
      case 101: // UP: ( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Beginning )
  class Lea_0096_0099 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0096_0099( TsmBase* oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 102, "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 103, "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0096_0101( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect::OK;
        case 103:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 102: // UP: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 103: // UP: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >)
  class Reg_0095_0096 : public TsmRegion
  {
  private:
    Ini_0096_0097* oIni_0096_0097; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> InitialState )
    Lea_0096_0098* oLea_0096_0098; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Idle )
    Lea_0096_0099* oLea_0096_0099; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Beginning )

  public:
    Reg_0095_0096( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0096_0097 = new Ini_0096_0097( this );
      oLea_0096_0098 = new Lea_0096_0098( this );
      oLea_0096_0099 = new Lea_0096_0099( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0096_0097;
      mStates[ 1 ] = oLea_0096_0098;
      mStates[ 2 ] = oLea_0096_0099;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0096_0100( TsmHandler& oHandler );
    void Tra_0096_0102( TsmHandler& oHandler );
    void Tra_0096_0103( TsmHandler& oHandler );
    void Tra_0096_0101( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect::OK;
        case 103:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 94:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 103:
        Tra_0096_0103( oHandler );
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm )
  class Fsm_0093_0095 : public TsmFsm
  {
  private:
    Reg_0095_0096* oReg_0095_0096; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >)

  public:
    Fsm_0093_0095( TsmBase* oParent )
    {
      TsmName = "DriverServerPsm";
      TsmParent = oParent;
      oReg_0095_0096 = new Reg_0095_0096( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0095_0096;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > Driver > DriverServer )
  class Cla_0082_0093 : public TsmProtocolClass
  {
  private:
    Fsm_0093_0095* oFsm_0093_0095; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm )
    TsmIPort_IDriverServer* TsmPI__Port; // ( Xmi > Data > Protocols > Driver > DriverServer > Port )
    TsmIPort_ICbDriverServer* Port; // ( Xmi > Data > Protocols > Driver > DriverServer > Port )
    TsmPSPort* mPSMessager;
    double dPar;
    long L10;

  public:
    Cla_0082_0093( TsmBase* oParent, string sInstanceName ) : dPar(1.0), L10(55)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0093_0095 = new Fsm_0093_0095( this );
      TsmPI__Port = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0093_0095;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICbDriverServer*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0093_0095->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1006( TsmHandler& oHandler );
    void Function_1007( TsmHandler& oHandler );
    long Function_1018( int iPar );
    void Function_1019( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0082_0093()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > Driver )
   ********************************************************************/

   // ( Xmi > Data > Protocols > Driver )
  class Pac_0060_0082 : public TsmPackage
  {
  public:
    Pac_0060_0082( TsmBase* oParent )
    {
      TsmName = "Driver";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  class Pac_0001_0060 : public TsmPackage
  {
  public:
    Pac_0001_0060( TsmBase* oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  class Pac_0001_0104 : public TsmPackage
  {
  public:
    Pac_0001_0104( TsmBase* oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )
  class Com_0110_0001 : public TsmPComponent
  {
  private:
    Cla_0082_0093* InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

  public:
    Com_0110_0001( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        return InsDriverServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        InsDriverServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv2 > User2 )
  class Com_0110_0003 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0110_0003( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > User2 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > User2 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv4 > User4 )
  class Com_0114_0005 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0114_0005( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv4 > User4 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv4 > User4 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )
  class Com_0122_0007 : public TsmPComponent
  {
  private:
    Cla_0082_0093* InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

  public:
    Com_0122_0007( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        return InsDriverServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        InsDriverServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )
  class Com_0126_0009 : public TsmPComponent
  {
  private:
    Cla_0082_0093* InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

  public:
    Com_0126_0009( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        return InsDriverServer->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_pp_Driver" )
      {
        InsDriverServer->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )
  class Com_0126_0011 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0126_0011( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ExecEnv5 > User5 )
  class Com_0130_0013 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0130_0013( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv5 > User5 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv5 > User5 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )
  class Com_0134_0015 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0134_0015( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )
  class Com_0138_0017 : public TsmPComponent
  {
  private:
    Cla_0061_0062* InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

  public:
    Com_0138_0017( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient->IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "d_rp_User" )
      {
        return InsCtlrClient->GetProvidedInterface( "Port" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "d_rp_User" )
      {
        InsCtlrClient->SetRequiredInterface( "Port", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Architecture > ThreadedExecEnv5 )
  class Com_0105_0138 : public TsmPComponent
  {
  private:
    Com_0138_0017* ThrUser5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )
    Com_0035_0048* ThrDriver5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrDriver5 )
    Com_0003_0017* ThrCtlr5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrCtlr5 )

  public:
    Com_0105_0138( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      ThrUser5 = new Com_0138_0017( this, "ThrUser5" );
      ThrDriver5 = new Com_0035_0048( this, "ThrDriver5" );
      ThrCtlr5 = new Com_0003_0017( this, "ThrCtlr5" );
      mNrComponents = 3;
      mComponents = new TsmComponent*[ 3 ];
      mComponents[ 0 ] = ThrUser5;
      mComponents[ 1 ] = ThrDriver5;
      mComponents[ 2 ] = ThrCtlr5;
    }

    void TsmConnect( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  class Pac_0105_0142 : public TsmPackage
  {
  public:
    Pac_0105_0142( TsmBase* oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  class Pac_0001_0105 : public TsmPackage
  {
  public:
    Pac_0001_0105( TsmBase* oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  };

   // ( Xmi )
  class TsmSystem : public TsmExecComponent
  {
  private:
    Com_0105_0138* ThreadedExecEnv5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 )

  public:
    TsmSystem( TsmBase* oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent*[ 1 ];
      ThreadedExecEnv5 = new Com_0105_0138( NULL, "ThreadedExecEnv5" );
      mComponents[ 0 ] = ThreadedExecEnv5;
    }
  };
}
#endif
