/*
 * TismTool  Tis Veugen, 2010-2012
 *
 * File: User.h
 */

#ifndef USER_H
#define USER_H

#include "TsmBase.h"
#include "TsmClass.h"
#include "TsmPComponent.h"
#include "TsmInterfaces.h"
using namespace std;
using namespace TsmRTE;

namespace Foreign
{
  class MyTsmIPort_ICbCtlrServer;
  class UserClass : public TsmClass, public ICbCtlrServer
  {
  private:
    TsmIPort_ICtlrServer* Port;
    MyTsmIPort_ICbCtlrServer* TsmPI__Port;
    int iRv;
    bool bCallback;

  public:
    UserClass( TsmBase* oParent, string sInstanceName );
    virtual ~UserClass();

    TsmInterfacePort* GetProvidedInterface( string sPortName );
    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface );
    void TsmRun( void* oObject );
    void CbStarted( float fCbStart );
  };


  class UserForeign : public TsmPComponent
  {
  private:
    UserClass* m_UserClass;

  public:
    UserForeign( TsmBase* oParent, string sInstanceName );
    ~UserForeign();

    TsmInterfacePort* GetProvidedInterface( string sPortName );
    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface );
    void TsmRun( void* oObject );
  };


  class MyTsmIPort_ICbCtlrServer : public TsmIPort_ICbCtlrServer
  {
  private:
    UserClass* m_UserClass;

  public:
    MyTsmIPort_ICbCtlrServer( UserClass* oParent )
      : TsmIPort_ICbCtlrServer( oParent )
      , m_UserClass( oParent )
    {
    }

    void CbStarted( float fCbStart )
    {
      m_UserClass->CbStarted( fCbStart );
    }
  };
}
#endif
