/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmEnvelope.h
 * version 2
 */
#ifndef TSM_ENVELOPE_H
#define TSM_ENVELOPE_H

#include "TsmTrigger.h"
#include "TsmClass.h"
using namespace std;

namespace TsmRTE
{
  class TsmEnvelope
  {
  private:
    TsmTrigger* mTrigger;
    TsmClass*   mTarget;

  public:
    TsmEnvelope()
    {
    }

    TsmEnvelope( TsmTrigger* oTrigger, TsmClass* oTarget )
    {
      this->mTrigger = oTrigger;
      this->mTarget  = oTarget;
    }

    TsmTrigger* getTrigger()
    {
      return mTrigger;
    }

    TsmClass* getTarget()
    {
      return mTarget;
    }

    bool GetDBU()
    {
      return mTrigger->GetDBU();
    }

    void HandleDBU( bool bDBU )
    {
      if ( bDBU )
      {
        mTrigger->DBU();
      }
    }

    string Snap()
    {
      return mTrigger->Snap();
    }
  };
}
#endif

