/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmCompound.h
 * version 2
 */
#ifndef TSM_COMPOUND_H
#define TSM_COMPOUND_H

#include <sstream>
#include "TsmState.h"
#include "TsmRegion.h"
#include "TsmException.h"
using namespace std;

namespace TsmRTE
{
  class TsmHandler;

  class TsmCompound : public TsmState
  {
  protected:
    int         mNrRegions;
    TsmRegion** mRegions;

  private:
    void ExecuteTriggerRegions( TsmHandler& oHandler );
    void ExecuteRegions( TsmHandler& oHandler, bool bTrigger );
    void HandlerTakeOver( TsmHandler& oHandler,  TsmHandler& hAll );

  public:
    TsmCompound()
      : mNrRegions( 0 )
    {
    }

    virtual ~TsmCompound()
    {
      if ( mNrRegions > 0 )
      {
        for ( int i=0; i<mNrRegions; i++ )
        {
          delete mRegions[i];
        }
        delete [] mRegions;
      }
    }

    void Initial( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );
    virtual void ExecuteTriggerCompound( TsmHandler& oHandler );

    virtual void AtMyExit( TsmHandler& oHandler )
    {
    }

    void ExitRegions( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    string TsmSnap();
    void TsmCheckVisit();
  };
}
#endif
