/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmFsm.cpp
 * version 3
 */
#include "TsmFsm.h"
#include "TsmHandler.h"
#include "TsmHandlerAction.h"
#include "TsmRecorder.h"
#include "TsmCompound.h"
using namespace std;

namespace TsmRTE
{
  void TsmFsm::ExecuteTriggerFsm( TsmHandler& oHandler )
  {
    ExecuteTrigger( oHandler );
    if ( ! oHandler.bTaken )
    {
      TsmRecorder::UnhandledFunction( oHandler.Trigger->ClassName() + " @ " +
        this->ClassName() + " : " + this->FullName()  );
    }
  }

  void TsmFsm::ExecuteTriggerless( TsmHandler& oHandler )
  {
    oHandler.Action = TsmHandlerAction::QUIT;
  }

  void TsmFsm::TsmReset1( TsmHandler& oHandler )
  {
    AtExit( oHandler );
  }

  void TsmFsm::TsmReset2( TsmHandler& oHandler )
  {
    Initial( oHandler );
  }

  string TsmFsm::TsmSnap()
  {
    return ":" + TsmCompound::TsmSnap();
  }
}
