/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmRegion.h
 * version 3
 */
#ifndef TSM_REGION_H
#define TSM_REGION_H

#include "TsmState.h"
using namespace std;

namespace TsmRTE
{
  class TsmHandler;

  class TsmRegion : public TsmState
  {
  protected:
    int         mNrStates;
    TsmState**  mStates;
    TsmState*   mCurrentState;
    bool        mbFinal;

  public:
    TsmRegion()
      : mNrStates( 0 )
      , mCurrentState( NULL )
      , mbFinal( false )
    {
    }

    virtual ~TsmRegion()
    {
      if ( mNrStates > 0 )
      {
        for ( int i=0; i<mNrStates; i++ )
        {
          delete mStates[i];
        }
        delete [] mStates;
      }
    }

    /**
     * This function should be overridden, or never be called.
     */
    virtual void Initial( TsmHandler& oHandler );

    void ExecuteTrigger( TsmHandler& oHandler );
    void ExecuteTriggerless( TsmHandler& oHandler )
    {
      // Prevent redefining oHandler.Action
    }
    void AtExit( TsmHandler& oHandler );
    void Reset();
    string TsmSnap();
    void TsmCheckVisit();
  };
}
#endif
