/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmRecorder.h
 * version 2
 */
#ifndef TSM_RECORDER_H
#define TSM_RECORDER_H

#include <vector>
using namespace std;

namespace TsmRTE
{
  class TsmClass;
  class TsmPort;

  class TsmRecorder
  {
  public:
    static int           NumberOfUnhandledFunctions;
    static int           NumberOfUnvisitedStates;
    static int           NumberOfUnvisitedTransitions;
    static int           NumberOfSyncReturnErrors;
    static int           NumberOfQueueOverflows;
  
  private:
    static vector<string> Records;
    static int            NrCalls;
    static bool           bEnable;
    static const string   Separator;

  public:
    static int getNumberOfRecords()
    {
      return Records.size();
    }

    static int getNumberOfExtCalls()
    {
      return NrCalls;
    }

    static void Reset()
    {
      Records.clear();
      NrCalls = 0;
      bEnable = false;
    }

    static void Enable();
    static void AddNative( string sNative );
    static void AddCall( string sCall, TsmClass* oSource, TsmPort* oPort );
    static void AddStates( string sStates );
    static void UnhandledFunction( string sEvent );
    static void UnvisitedState( string sEvent );
    static void UnvisitedTransition( string sState, string sEvent );
    static void SyncReturnError( string sEvent );
    static void QueueOverflow();
    static void Show( string sEvent );
    static void Show( string sEvent, int iNrRecords );
  };
}
#endif
